-- MySQL dump 8.17
--
-- Host: localhost    Database: ipplan
---------------------------------------------------------

--
-- Table structure for table 'area'
--

CREATE TABLE area (
  areaaddr int(10) unsigned NOT NULL default '0',
  descrip varchar(80) NOT NULL default '',
  areaindex int(11) NOT NULL auto_increment,
  customer smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (areaindex),
  UNIQUE KEY customer (customer,descrip),
  UNIQUE KEY areaaddr (areaaddr,customer)
) TYPE=innodb;

--
-- Table structure for table 'auditlog'
--

CREATE TABLE auditlog (
  action varchar(80) NOT NULL default '',
  dt timestamp(14) NOT NULL,
  KEY dt (dt)
) TYPE=innodb;

--
-- Table structure for table 'base'
--

CREATE TABLE base (
  baseaddr int(11) unsigned NOT NULL default '0',
  subnetsize mediumint(9) unsigned NOT NULL default '0',
  descrip varchar(80) NOT NULL default '',
  baseindex int(11) NOT NULL auto_increment,
  admingrp varchar(40) NOT NULL default '',
  customer smallint(6) unsigned NOT NULL default '0',
  lastmod timestamp(14) NOT NULL,
  userid varchar(40) NOT NULL default '',
  swipmod datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (baseindex),
  UNIQUE KEY baseaddr (baseaddr,customer),
  KEY customer (customer),
  KEY admingrp (admingrp)
) TYPE=innodb COMMENT='Define base addresses';

--
-- Table structure for table 'custinfo'
--

CREATE TABLE custinfo (
  customer smallint(5) unsigned NOT NULL default '0',
  org varchar(100) NOT NULL default '',
  street varchar(255) NOT NULL default '',
  city varchar(80) NOT NULL default '',
  state char(2) NOT NULL default '',
  zipcode varchar(10) NOT NULL default '',
  cntry char(2) NOT NULL default '',
  maint varchar(80) NOT NULL default '',
  nichandl varchar(80) NOT NULL default '',
  lname varchar(80) NOT NULL default '',
  fname varchar(80) NOT NULL default '',
  mname varchar(80) NOT NULL default '',
  torg varchar(100) NOT NULL default '',
  tstreet varchar(255) NOT NULL default '',
  tcity varchar(80) NOT NULL default '',
  tstate char(2) NOT NULL default '',
  tzipcode varchar(10) NOT NULL default '',
  tcntry char(2) NOT NULL default '',
  phne varchar(20) NOT NULL default '',
  mbox varchar(100) NOT NULL default '',
  PRIMARY KEY  (customer)
) TYPE=innodb;

--
-- Table structure for table 'customer'
--

CREATE TABLE customer (
  custdescrip varchar(80) NOT NULL default '',
  customer smallint(6) unsigned NOT NULL auto_increment,
  admingrp varchar(40) NOT NULL default '',
  PRIMARY KEY  (customer),
  UNIQUE KEY custdescrip (custdescrip),
  KEY admingrp (admingrp)
) TYPE=innodb;

--
-- Table structure for table 'grp'
--

CREATE TABLE grp (
  grpdescrip varchar(80) NOT NULL default '',
  grp varchar(40) NOT NULL default '',
  grpopt int(11) unsigned NOT NULL default '0',
  createcust enum('N','Y') NOT NULL default 'N',
  PRIMARY KEY  (grp),
  KEY grpdescrip (grpdescrip)
) TYPE=innodb;

--
-- Table structure for table 'ipaddr'
--

CREATE TABLE ipaddr (
  ipaddr int(11) unsigned NOT NULL default '0',
  userinf varchar(80) NOT NULL default '',
  location varchar(80) NOT NULL default '',
  telno varchar(15) NOT NULL default '',
  descrip varchar(80) NOT NULL default '',
  baseindex int(11) NOT NULL default '0',
  lastmod timestamp(14) NOT NULL,
  userid varchar(40) NOT NULL default '',
  PRIMARY KEY  (ipaddr,baseindex),
  KEY baseindex (baseindex)
) TYPE=innodb;

--
-- Table structure for table 'range'
--

CREATE TABLE range (
  rangeaddr int(10) unsigned NOT NULL default '0',
  rangesize mediumint(8) unsigned NOT NULL default '0',
  descrip varchar(80) NOT NULL default '',
  rangeindex int(10) NOT NULL auto_increment,
  areaindex int(10) NOT NULL default '0',
  customer smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (rangeindex),
  UNIQUE KEY rangeaddr (rangeaddr,customer),
  UNIQUE KEY customer (customer,descrip),
  KEY areaindex (areaindex)
) TYPE=innodb;

--
-- Table structure for table 'revdns'
--

CREATE TABLE revdns (
  customer smallint(8) unsigned NOT NULL default '0',
  hname varchar(100) NOT NULL default '',
  ipaddr varchar(15) NOT NULL default '',
  horder tinyint(4) unsigned NOT NULL default '0',
  KEY customer (customer)
) TYPE=innodb;

--
-- Table structure for table 'schema'
--

CREATE TABLE schema (
  version int(11) default NULL
) TYPE=innodb;

INSERT INTO schema SET version=6;

--
-- Table structure for table 'users'
--

CREATE TABLE users (
  userid varchar(40) binary NOT NULL default '',
  userdescrip varchar(80) NOT NULL default '',
  password varchar(40) binary NOT NULL default '',
  PRIMARY KEY  (userid)
) TYPE=innodb COMMENT='User info';

--
-- Table structure for table 'usergrp'
--

CREATE TABLE usergrp (
  userid varchar(40) binary NOT NULL default '',
  grp varchar(40) NOT NULL default '',
  UNIQUE KEY userid (userid,grp),
  KEY grp (grp)
) TYPE=innodb;

--
-- Table structure for table 'bounds'
--

CREATE TABLE bounds (
  boundsaddr int(10) unsigned NOT NULL default '0',
  boundssize int(10) unsigned NOT NULL default '0',
  grp varchar(40) NOT NULL default '',
  KEY grp (grp),
  KEY boundsaddr (boundsaddr)
) TYPE=innodb;

