<?php

// IPplan v3.02
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/lib/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Create a new user");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "admin.php");

$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

if ($HTTP_POST_VARS) {
   $userid=trim($userid);
   $userdescrip=trim($userdescrip);
   if (AUTH_INTERNAL) {
      $password1=trim($password1);
      $password2=trim($password2);
   }
   else {
      // generate randon password in case user changes authentication
      // from external to internal at some point
      $password1=$password2=rand(10000, 1000000);
   }

   if (strlen($userid) < 2) {
      $formerror .= my_("The user-id must be longer")."<br>";
   }
   if (strlen($userdescrip) < 2) {
      $formerror .= my_("The user description must be longer")."<br>";
   }
   if (strlen($password1) < 5 or strlen($password2) < 5) {
      $formerror .= my_("The password entered must be at least five characters")."<br>";
   }
   if ($password1 != $password2) {
      $formerror .= my_("The passwords entered do not match")."<br>";
   }

   if (!$formerror) {
      $password=crypt($password1, 'xq');

      $ds->DbfTransactionStart();
      // emulates mysql REPLACE
      $result=&$ds->ds->Execute("DELETE FROM users
                             WHERE userid=".$ds->ds->qstr($userid));
      $result=&$ds->ds->Execute("INSERT INTO users
                                (userid, userdescrip, password) 
                             VALUES
                                (".$ds->ds->qstr($userid).",
                                 ".$ds->ds->qstr($userdescrip).",
                                 ".$ds->ds->qstr($password).")");

      if ($result) {
         $ds->DbfTransactionEnd();

         if ($ds->ds->Affected_Rows() == 2)
            insert($w,block(my_("Existing user overwritten")));
         else
            insert($w,block(my_("User created")));
      }
      else {
         $formerror .= my_("User could not be created")."<br>";
      }
   }
}

if (!$HTTP_POST_VARS || $formerror) {
   insert($w,text($formerror, array("color"=>"red")));

   // display opening text
   insert($w,block("<br>$title"));

   // start form
   insert($w, $f = form(array("method"=>"post",
                              "action"=>$PHP_SELF)));

   insert($f,block("<br>".my_("User-id (case sensitive!):")."<br>"));
   insert($f,input_text(array("name"=>"userid",
                              "value"=>"$userid",
                              "size"=>"40",
                              "maxlength"=>"40")));

   insert($f,block("<br>".my_("User's fullname:")."<br>"));
   insert($f,input_text(array("name"=>"userdescrip",
                              "value"=>"$userdescrip",
                              "size"=>"80",
                              "maxlength"=>"80")));

   if (AUTH_INTERNAL) {
      insert($f,block("<br>".my_("Password (case sensitive!):")."<br>"));
      insert($f,password(array("name"=>"password1",
                               "value"=>"$password1",
                               "size"=>"40",
                               "maxlength"=>"40")));

      insert($f,block("<br>".my_("Password (again):")."<br>"));
      insert($f,password(array("name"=>"password2",
                               "value"=>"$password2",
                               "size"=>"40",
                               "maxlength"=>"40")));
   }

   insert($f,generic("br"));
   insert($f,submit(array("value"=>my_("Submit"))));
   insert($f,freset(array("value"=>my_("Clear"))));
}

printhtml($w);

?>
