<?php

// IPplan v3.02
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// when the database layout changes, bump up this value.
define("SCHEMA", 6);

require_once("/usr/lib/adodb/adodb.inc.php");
require_once("class.dbflib.php");

// checks to see if user is using latest schema
function CreateSchema() {

$taboptarray = array('mysql' => 'TYPE=MYISAM',
                     'maxsql' => 'TYPE=INNODB',
                     'oci8po' => 'tablespace users');

$tables['area']=array(
   array('areaaddr', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('descrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('areaindex',  'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull')
);
$indexes['area']=array(
   array('customer', 'customer,descrip', array('UNIQUE')),
   array('areaaddr', 'areaaddr,customer', array('UNIQUE'))
);

$tables['auditlog']=array(
   array('action', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('dt', 'T', 'DEFTIMESTAMP', 'NotNull'),
);
$indexes['auditlog']=array(
   array('dt', 'dt')
);

$tables['base']=array(
   array('baseaddr', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('subnetsize', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('descrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('baseindex',  'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('admingrp', 'C', '40', 'DEFAULT' => '', 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('lastmod', 'T', 'DEFTIMESTAMP', 'NotNull'),
   array('userid', 'C', '40', 'DEFAULT' => '', 'NotNull'),
   array('swipmod', 'T', 'NotNull')
);
$indexes['base']=array(
   array('baseaddr', 'baseaddr,customer', array('UNIQUE')),
   array('customer', 'customer'),
   array('admingrp', 'admingrp')
);

$tables['custinfo']=array(
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('org', 'C', '100', 'DEFAULT' => '', 'NotNull'),
   array('street', 'C', '255', 'DEFAULT' => '', 'NotNull'),
   array('city', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('state', 'C', '2', 'DEFAULT' => '', 'NotNull'),
   array('zipcode', 'C', '10', 'DEFAULT' => '', 'NotNull'),
   array('cntry', 'C', '2', 'DEFAULT' => '', 'NotNull'),
   array('maint', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('nichandl', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('lname', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('fname', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('mname', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('torg', 'C', '100', 'DEFAULT' => '', 'NotNull'),
   array('tstreet', 'C', '255', 'DEFAULT' => '', 'NotNull'),
   array('tcity', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('tstate', 'C', '2', 'DEFAULT' => '', 'NotNull'),
   array('tzipcode', 'C', '10', 'DEFAULT' => '', 'NotNull'),
   array('tcntry', 'C', '2', 'DEFAULT' => '', 'NotNull'),
   array('phne', 'C', '20', 'DEFAULT' => '', 'NotNull'),
   array('mbox', 'C', '100', 'DEFAULT' => '', 'NotNull')
);

$tables['customer']=array(
   array('custdescrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('admingrp', 'C', '40', 'DEFAULT' => '', 'NotNull')
);
$indexes['customer']=array(
   array('custdescrip', 'custdescrip', array('UNIQUE')),
   array('admingrp', 'admingrp')
);

$tables['grp']=array(
   array('grpdescrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('grp', 'C', '40', 'DEFAULT' => '', 'NotNull', 'PRIMARY'),
   array('createcust', 'C', '1', 'DEFAULT' => 'N', 'NotNull'),
   array('grpopt', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull')
);
$indexes['grp']=array(
   array('grpdescrip', 'grpdescrip')
);

// order of columns for PRIMARY KEY is important!!
$tables['ipaddr']=array(
   array('ipaddr', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('userinf', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('location', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('telno', 'C', '15', 'DEFAULT' => '', 'NotNull'),
   array('descrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('baseindex', 'I8', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('lastmod', 'T', 'DEFTIMESTAMP', 'NotNull'),
   array('userid', 'C', '40', 'DEFAULT' => '', 'NotNull')
);
$indexes['ipaddr']=array(
   array('baseindex', 'baseindex')
);

$tables['range']=array(
   array('rangeaddr', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('rangesize', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('descrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('rangeindex',  'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('areaindex',  'I8', 'DEFAULT' => 0, 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull')
);
$indexes['range']=array(
   array('rangeaddr', 'rangeaddr,customer', array('UNIQUE')),
   array('customer', 'customer,descrip', array('UNIQUE')),
   array('areaindex', 'areaindex')
);

$tables['revdns']=array(
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('hname', 'C', '100', 'DEFAULT' => '', 'NotNull'),
   array('ipaddr', 'C', '15', 'DEFAULT' => '', 'NotNull'),
   array('horder', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'TINYINT UNSIGNED':'I1', 'DEFAULT' => 0, 'NotNull')
);
$indexes['revdns']=array(
   array('customer', 'customer')
);

if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql") {
   $tables['version']=array(
      array('version', 'I4', 'DEFAULT' => 0, 'NotNull')
   );
}
else {
   $tables['schema']=array(
      array('version', 'I4', 'DEFAULT' => 0, 'NotNull')
   );
}

$tables['users']=array(
   array('userid', 'C', '40', 'DEFAULT' => '', 'NotNull', 'PRIMARY'),
   array('userdescrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('password', 'C', '40', 'DEFAULT' => '', 'NotNull')
);

$tables['usergrp']=array(
   array('userid', 'C', '40', 'DEFAULT' => '', 'NotNull'),
   array('grp', 'C', '40', 'DEFAULT' => '', 'NotNull')
);
$indexes['usergrp']=array(
   array('userid', 'userid,grp', array('UNIQUE')),
   array('grp', 'grp')
);

$tables['bounds']=array(
   array('boundsaddr', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('boundssize', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('grp', 'C', '40', 'DEFAULT' => '', 'NotNull')
);
$indexes['bounds']=array(
   array('grp', 'grp'),
   array('boundsaddr', 'boundsaddr')
);


   // check php version
   if (phpversion() < "4.0.3") {
      die("You need php version 4.0.3 or later");
   }

   // cant use myError here as we do not have access to layout yet!
//   $ds=new IPplanDbf() or die(my_("Could not connect to database"));
   $ds = &ADONewConnection(DBF_TYPE);
   $ds->Connect(DBF_HOST, DBF_USER, DBF_PASSWORD, DBF_NAME);
   $ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

   // Then create a data dictionary object, using this connection
   $dict = NewDataDictionary($ds);

   // loop through tables and indexes arrays to create SQL
   foreach($tables as $tblname => $fldarray) {
      $sqlarray = $dict->CreateTableSQL($tblname, $fldarray, $taboptarray);
      PrintSQL($sqlarray[0]);
//   $dict->ExecuteSQLArray($sqlarray);
      if (@isset($indexes[$tblname])) {
         foreach($indexes[$tblname] as $idxarray) {
            $sqlarray = $dict->CreateIndexSQL($idxarray[0], $tblname, $idxarray[1], $idxarray[2]);
            PrintSQL($sqlarray[0]);
//   $dict->ExecuteSQLArray($sqlarray);
         }
      }
   }
   if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql") {
      PrintSQL("INSERT INTO version (version) VALUES (6)");
   }
   else {
      PrintSQL("INSERT INTO schema (version) VALUES (6)");
   }

}

function PrintSQL($sqlarray) {

    echo '<pre>';
    echo $sqlarray;
    if (DBF_TYPE=='sybase' or 
        DBF_TYPE=='ado_mssql' or 
        DBF_TYPE=='mssql') {
        echo "\nGO\n";
    }
    else if (DBF_TYPE=='oci8po') {
        echo "\n/\n";
    }
    else {
        echo ";";
    }
    echo '</pre>';
    echo '<p>';

}

CreateSchema();

?>
