<?php

// IPplan v3.02
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

// this array contains the statements that need to be executed in
// order to bring a previous version up to the latest schema


// placed in external file to prevent load for every index page

$schema_mysql=
        array(0 => array("CREATE TABLE schema (version int)",
                         "INSERT INTO schema (version) VALUES (1)"),
              1 => array("CREATE TABLE custinfo (
                          customer smallint(5) unsigned NOT NULL default '0',
                          org varchar(100) NOT NULL default '',
                          street varchar(255) NOT NULL default '',
                          city varchar(80) NOT NULL default '',
                          state char(2) NOT NULL default '',
                          zipcode varchar(10) NOT NULL default '',
                          cntry char(2) NOT NULL default '',
                          maint varchar(80) NOT NULL default '',
                          nichandl varchar(80) NOT NULL default '',
                          lname varchar(80) NOT NULL default '',
                          fname varchar(80) NOT NULL default '',
                          mname varchar(80) NOT NULL default '',
                          torg varchar(100) NOT NULL default '',
                          tstreet varchar(255) NOT NULL default '',
                          tcity varchar(80) NOT NULL default '',
                          tstate char(2) NOT NULL default '',
                          tzipcode varchar(10) NOT NULL default '',
                          tcntry char(2) NOT NULL default '',
                          phne varchar(20) NOT NULL default '',
                          mbox varchar(100) NOT NULL default '',
                          PRIMARY KEY  (customer)
                          )",
                         "CREATE TABLE revdns (
                          customer smallint(8) unsigned NOT NULL default '0',
                          hname varchar(100) NOT NULL default '',
                          ipaddr varchar(15) NOT NULL default '',
                          horder tinyint(4) unsigned NOT NULL default '0',
                          KEY customer (customer)
                          )",
                         "ALTER TABLE grp ADD createcust ENUM('N', 'Y') 
                          DEFAULT 'N' NOT NULL",
                         "UPDATE schema SET version=2"),
              2 => array("ALTER TABLE base 
                          CHANGE `customer` `customer` SMALLINT(6) 
                          UNSIGNED DEFAULT '0' NOT NULL",
                         "ALTER TABLE ipaddr 
                          ADD `lastmod` TIMESTAMP NOT NULL, 
                          ADD `userid` VARCHAR(40) NOT NULL",
                         "ALTER TABLE base 
                          ADD `lastmod` TIMESTAMP NOT NULL, 
                          ADD `userid` VARCHAR(40) NOT NULL,
                          ADD `swipmod` DATETIME NOT NULL",
                         "UPDATE schema SET version=3"),
              3 => array("CREATE TABLE `bounds` (
                          `boundsaddr` int(10) unsigned NOT NULL default '0',
                          `boundssize` int(10) unsigned NOT NULL default '0',
                          `grp` varchar(40) NOT NULL default '',
                          KEY `grp` (`grp`),
                          KEY `boundsaddr` (`boundsaddr`)
                          )",
                         "UPDATE schema SET version=4"),
              4 => array("ALTER TABLE `user` RENAME `users`",
                         "ALTER TABLE `ipaddr` 
                          CHANGE `user` `userinf` VARCHAR(80) NOT NULL",
                         "UPDATE schema SET version=5"),
              5 => array("ALTER TABLE `grp` 
                          ADD `grpopt` INT UNSIGNED NOT NULL",
                         "UPDATE grp SET grpopt=1",
                         "UPDATE schema SET version=6"),
);

$schema_other=
        array(5 => array("Add an additional column to the `grp` table - the column must be called `grpopt` and of type INT UNSIGNED NOT NULL with a default value of 0",
                         "UPDATE grp SET grpopt=1",
                         "UPDATE schema SET version=6"),
);

?>

