<?php

// IPplan v3.02
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/lib/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$grps=$auth->authenticate();

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Results of your search");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "../index.php", true);

if (!$HTTP_GET_VARS and !$HTTP_POST_VARS) {
   myError($w, my_("You cannot reload or bookmark this page!"));
}

$ds=new IPplanDbf() or myError($w, "Could not connect to database");

// script gets called back from modifyipform script so that user does
// not need to press back button
if ($HTTP_POST_VARS) {
   if ($grp=$ds->GetBaseGrp($baseindex)) {
      if (in_array($grp, $grps) or 
            $ds->TestCustomerGrp($baseindex, $HTTP_SERVER_VARS[AUTH_VAR])) {

         if ($md5str!=$ds->GetMD5($ip, $baseindex))
            myError($w,my_("Another user modified the information before you saved - restart")."<br>");

         $ds->DbfTransactionStart();
         if ($ds->ModifyIP($ip, $baseindex, $user, $location, 
                      $telno, $descrip, $action) == 0) {
            $ds->DbfTransactionEnd();
            insert($w,text(my_("IP address details modified")));
         }
         else
            insert($w,text(my_("IP address details could not be modified"),
                      array("color"=>"#FF0000")));
      }
      else
         insert($w,text(my_("You are not the owner of the subnet"),
                    array("color"=>"#FF0000")));
   }
   else
      insert($w,text(my_("Could not find the owner of the subnet - subnet possibly deleted by another user")."<br>",
                    array("color"=>"#FF0000")));
}
    
// get info from base table
$result=$ds->GetBaseFromIndex($baseindex);

$row = $result->FetchRow();
$maxcnt=$row["subnetsize"];
$baseaddr=$row["baseaddr"];

// sanity check if MAXTABLESIZE in config.php is modified on the fly
// and person has maybe bookmarked paged
if ($baseaddr+$block*MAXTABLESIZE >= $baseaddr+$maxcnt) {
   myError($w, my_("This page was bookmarked and contains invalid information which cannot be displayed anymore - restart from main menu"));
}

insert($w,block("<h3>"));
insert($w,text(my_("Subnet:")." ".
                  inet_ntoa($baseaddr)." ".my_("Mask:")." ".
                  inet_ntoa(inet_aton(ALLNETS)+1 -
                    $maxcnt)."/".inet_bits($maxcnt)));
insert($w,block("<br>"));
insert($w,text(my_("Description:")." ".$row["descrip"]));
insert($w,block("</h3>"));

if (!$showactive) {
   insert($w,anchor($PHP_SELF."?baseindex=".$baseindex."&showactive=1&block=".$block,
                    my_("Show used addresses")));
 
   insert($w,block(my_(" This can take a while as each address is polled.  Green is active, Red is inactive")."<br>"));
}
if (!$showdns) {
   insert($w,anchor($PHP_SELF."?baseindex=".$baseindex."&showdns=1&block=".$block,
                    my_("Show DNS changes")));
 
   insert($w,block(my_(" Show descriptions that do not match DNS reverse entries. Red is new DNS value")."<br>"));
}

insert($w,block("<p>"));

insert($w,$tbig = table(array("cols"=>"3")));
insert($tbig,$c = cell());
insert($c,block(my_("Select multiple addresses to do a bulk change")));
insert($c,block("<br>".my_("Ideal for reserving DHCP ranges")));

// start form for drop down list
insert($c, $f = form(array("name"=>"MODIFYMULTIPLE",
                           "method"=>"post",
                           "action"=>"modifyipformmul.php")));

// build "option select" list
$lst=array();
for ($i=$block*MAXTABLESIZE; $i < $block*MAXTABLESIZE+MAXTABLESIZE; $i++) {
   if ($i > 0 and $i < $maxcnt-1) {
        $col=$row["baseaddr"]+$i;
        $lst["$col"]=inet_ntoa($row["baseaddr"]+$i);
   }
}
insert($f,selectbox($lst,
                 array("name"=>"ip[]", 
                       "multiple size"=>"5")));

insert($f,hidden(array("name"=>"baseindex",
                       "value"=>"$baseindex")));
insert($f,hidden(array("name"=>"block",
                       "value"=>"$block")));

insert($f,generic("br"));
insert($f,submit(array("value"=>my_("Submit"))));
insert($f,freset(array("value"=>my_("Clear"))));

// start form for "Use next address" button
insert($c, $f = form(array("name"=>"MODIFYNEXTFREE",
                           "method"=>"get",
                           "action"=>"modifyipform.php")));

insert($f,hidden(array("name"=>"baseindex",
                       "value"=>"$baseindex")));
insert($f,hidden(array("name"=>"subnetsize",
                       "value"=>"$maxcnt")));
insert($f,hidden(array("name"=>"baseaddr",
                       "value"=>"$baseaddr")));
insert($f,hidden(array("name"=>"block",
                       "value"=>"$block")));

insert($f,submit(array("value"=>my_("Use next available address"))));

// get detail from ipaddr table - could be nothing!
$result=$ds->GetSubnetDetails($baseindex);
// emulate for databases that do not have RecordCount
$recs=$result->PO_RecordCount("ipaddr", "baseindex=$baseindex");

insert($tbig,$c = cell());
// create stats cell for later use
insert($tbig,$cstats = cell(array("valign"=>"top")));

// create a table
insert($w,$tbig = table(array("cols"=>"1", "bgcolor"=>"#00CCFF")));
insert($tbig,$c = cell());
insert($c,$t = table(array("cols"=>"7",
                           "cellspacing"=>"1",
                           "bgcolor"=>"#99CCFF")));
// draw heading
insert($t,$c = cell());
insert($c,block("<b>".my_("IP address")."</b>"));
insert($t,$c = cell());
insert($c,block("<b>".my_("User")."</b>"));
insert($t,$c = cell());
insert($c,block("<b>".my_("Location")."</b>"));
insert($t,$c = cell());
insert($c,block("<b>".my_("Device description")."</b>"));
insert($t,$c = cell());
insert($c,block("<b>".my_("Telephone Number")."</b>"));
insert($t,$c = cell());
insert($c,block("<b>".my_("Last modified")."</b>"));
insert($t,$c = cell());
insert($c,block("<b>".my_("Changed by")."</b>"));

setdefault("cell",array("bgcolor"=>"#FFFFCC"));
 
// fastforward till first record if not first block of data
while ($row = $result->FetchRow() and 
       $row["ipaddr"] < $baseaddr+$block*MAXTABLESIZE);

$res=0;
for ($i=$block*MAXTABLESIZE; $i < $block*MAXTABLESIZE+MAXTABLESIZE; $i++) {

   // did user select to scan if address is active?
   if ($showactive) {
      if (ScanHost(inet_ntoa($baseaddr+$i)))
         insert($t,$c = cell(array("bgcolor"=>"#00FF00")));
      else
         insert($t,$c = cell(array("bgcolor"=>"#FF0000")));
   }
   else {
      insert($t,$c = cell());
   }

   // strange! brackets must be there in php 4.0.4p1, else code wrong!
   insert($c,anchor("modifyipform.php?ip=".($baseaddr+$i).
                    "&baseindex=".$baseindex."&block=".$block,
                    inet_ntoa($baseaddr+$i)));
 
   insert($t,$c = cell());
   // network address
   if ($i == 0) {
      insert($c,text(my_("Reserved - network address"), 
                array("color"=>"#FF0000")));
      insert($c,block("<br>"));
   }
   // broadcast address
   else if ($i == $maxcnt-1) {
      insert($c,text(my_("Reserved - broadcast address"), 
                array("color"=>"#FF0000")));
      insert($c,block("<br>"));
   }
   // display only rows that exist in database
   if ($row["ipaddr"] == $baseaddr+$i) {
      // count reserved addresses
      if ($i == 0 or $i == $maxcnt-1)
         $res++;
      insert($c,text($row["userinf"]));
      insert($t,$c = cell());
      insert($c,text($row["location"]));
      insert($t,$c = cell());
      insert($c,text($row["descrip"]));
      if ($showdns) {
         $dnsdescrip=gethostbyaddr(inet_ntoa($baseaddr+$i));
         if ($dnsdescrip != inet_ntoa($baseaddr+$i) and 
             $dnsdescrip != $row["descrip"]) {
            if (!empty($row["descrip"])) {
               insert($c,block("<br>"));
            }
            insert($c,text($dnsdescrip, array("color"=>"#FF0000")));
         }
      }
      insert($t,$c = cell());
      insert($c,text($row["telno"]));
      insert($t,$c = cell());
      insert($c,block($result->UserTimeStamp($row["lastmod"], "M d Y H:i:s")));
      insert($t,$c = cell());
      insert($c,text($row["userid"]));

      $row = $result->FetchRow();
   }
   else {
      insert($t,$c = cell());
      insert($t,$c = cell());
      if ($showdns) {
         $dnsdescrip=gethostbyaddr(inet_ntoa($baseaddr+$i));
         if ($dnsdescrip!=inet_ntoa($baseaddr+$i)) {
            insert($c,text($dnsdescrip, array("color"=>"#FF0000")));
         }
      }
      insert($t,$c = cell());
      insert($t,$c = cell());
      insert($t,$c = cell());
   }

   // exit loop when subnet is done - protects against MAXTABLESIZE
   // not being a power of two (eg 64, 128 etc)
   if ($baseaddr+$i >= $baseaddr+$maxcnt-1) {
      break;
   }
}

insert($w,block("<p>"));

// display stats
$res=2-$res;
insert($cstats,block("<b>".my_("Subnet Summary")."</b><p>"));
insert($cstats,block(my_("Total addresses:")." ".$maxcnt."<br>"));
insert($cstats,block(my_("Used addresses:")." ".($recs+$res)."<br>"));
insert($cstats,block(my_("Free addresses:")." ".($maxcnt-$recs-$res)."<br>"));
insert($cstats,block(my_("Utilization:")." ".(round(($recs+$res)/$maxcnt*100,2))."%<br>"));
insert($cstats,block(my_("Efficiency:")." ".(round(($recs)/$maxcnt*100,2))."%<br>"));


// display various blocks of subnet
$cnt=0;
for ($i=$baseaddr; $i<$baseaddr+$maxcnt; $i=$i+MAXTABLESIZE) {
    if ($block != $cnt) {
       if ($i+MAXTABLESIZE >= $baseaddr+$maxcnt-1) {
          insert($w,anchor($PHP_SELF."?baseindex=".$baseindex."&block=".$cnt."&showactive=".$showactive,
                           inet_ntoa($i)." - ".inet_ntoa($baseaddr+$maxcnt-1)));
       }
       else {
          insert($w,anchor($PHP_SELF."?baseindex=".$baseindex."&block=".$cnt."&showactive=".$showactive,
                           inet_ntoa($i)." - ".inet_ntoa($i+MAXTABLESIZE-1)));
       }

    insert($w,block("<br>"));
    }
    $cnt++;
}

$result->Close();
printhtml($w);

?>
