<?php

// IPplan v3.02
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/lib/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

if (!ANONYMOUS) {
   $auth = new SQLAuthenticator(REALM, REALMERROR);

   // And now perform the authentication
   $auth->authenticate();
}

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);

setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Modify IP address details");
newhtml($w);

insert($w, wheader($title));
myheading($w, $title, "../index.php", true);

if (!$HTTP_GET_VARS) {
   myError($w, my_("You cannot reload or bookmark this page!"));
}

// basic sequence is connect, search, interpret search
// result, close connection

$ds=new IPplanDbf() or myError($w, my_("Could not connect to database"));

// already have ip address to modify
if ($ip) {
   $iptemp=inet_ntoa($ip);

   // query could return nothing which is OK
   $result=&$ds->ds->Execute("SELECT userinf, location, telno, ipaddr, descrip
                           FROM ipaddr
                           WHERE ipaddr=$ip AND baseindex=$baseindex");

   $row = $result->FetchRow();
}
// find next free address to modify
else {
   // order is important here!
   $result=&$ds->ds->Execute("SELECT ipaddr
                          FROM ipaddr
                          WHERE baseindex=$baseindex
                          ORDER BY ipaddr");

   $cnt=0;
   while($row = $result->FetchRow()) {
      // protect against network and broadcast address potentially
      // existing in database
      if ($row["ipaddr"] > $baseaddr and 
            $row["ipaddr"] < $baseaddr+$subnetsize-1)
         $arr[$cnt++]=$row["ipaddr"];
   }

   $cnt=0;
   for ($i=$baseaddr+1; $i < $baseaddr+$subnetsize-1; $i++) {
      if ($arr[$cnt] == $i)
         $cnt++;
      else
         break;
   }
   $ip=$i;
   $iptemp=inet_ntoa($ip);

   if ($ip==$baseaddr+$subnetsize-1)
      myError($w, my_("There are no available addresses"));
}

// save md5str for check in displaysubnet.php to see if info has
// been modified since start of edit
$md5str=$ds->GetMD5($ip, $baseindex);

insert($w,block("<br><b>".my_("IP Address to modify:")." ".$iptemp."</b>"));
if ($ipplanPoll and ScanHost($iptemp, 1))
   insert($w,text(my_(" (Address active on network) "),
             array("color"=>"#FF0000")));
insert($w,block(" | "));

insert($w,anchor("whois.php?lookup=".$iptemp,
                  my_("Whois")));
insert($w,block(" | "));
 
insert($w,anchor("dns.php?ip=".$iptemp,
                  my_("DNS")));
insert($w,block(" | "));

insert($w,anchor("modifyipform.php?ip=".$ip.
                 "&baseindex=".$baseindex."&block=".$block.
                 "&updatedescrip=1",
                 my_("Update description from DNS")));

insert($w,generic("br"));

// start form for modify
insert($w, $f = form(array("name"=>"MODIFY",
                           "method"=>"post",
                           "action"=>"displaysubnet.php")));

insert($f,block("<br>".my_("User")."<br>"));
insert($f,input_text(array("name"=>"user",
                           "value"=>$row["userinf"],
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($f,block("<br>".my_("Location")."<br>"));
insert($f,input_text(array("name"=>"location",
                           "value"=>$row["location"],
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($f,block("<br>".my_("Device description")."<br>"));

$descrip=$row["descrip"];
if ($updatedescrip==1) {
   $dnsdescrip=gethostbyaddr($iptemp);
   if ($dnsdescrip != $iptemp) {
       $descrip=$dnsdescrip;
   }
}
insert($f,input_text(array("name"=>"descrip",
                           "value"=>$descrip,
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($f,block("<br>".my_("Telephone number")."<br>"));
insert($f,input_text(array("name"=>"telno",
                           "value"=>$row["telno"],
                           "size"=>"15",
                           "maxlength"=>"15")));
insert($f,hidden(array("name"=>"baseindex",
                      "value"=>"$baseindex")));
insert($f,hidden(array("name"=>"ip",
                      "value"=>"$ip")));
insert($f,hidden(array("name"=>"block",
                      "value"=>"$block")));
insert($f,hidden(array("name"=>"md5str",
                      "value"=>"$md5str")));

insert($f,generic("br"));
insert($f,submit(array("value"=>my_("Submit"))));
insert($f,freset(array("value"=>my_("Clear"))));

// start form for delete
// all info will be blank, thus record will be deleted
$settings=array("name"=>"DELETE",
                "method"=>"post",
                "action"=>"displaysubnet.php");
if ($ipplanParanoid)
   $settings["onsubmit"]="return confirm('".my_("Are you sure?")."')";
insert($w, $f = form($settings));

insert($f,hidden(array("name"=>"baseindex",
                      "value"=>"$baseindex")));
insert($f,hidden(array("name"=>"ip",
                      "value"=>"$ip")));
insert($f,hidden(array("name"=>"action",
                      "value"=>"delete")));
insert($f,hidden(array("name"=>"block",
                      "value"=>"$block")));
insert($f,hidden(array("name"=>"md5str",
                      "value"=>"$md5str")));

insert($f,submit(array("value"=>my_("Delete record"))));
insert($f,block(my_("WARNING: Deleting an entry does not preserve the last modified information as the record is completely removed from the database to conserve space.")."<br>"));

printhtml($w);

?>
